<!-- [QPRTemplateStart: jsportaltoolbarutils.tpl] -->
<#Include template="jsutils.tpl">

<script type="text/javascript">
var _sDefaultBookmarkName = "";

function sGetViewName()
{
  return "<#ViewName ENC="html">";
}

function OpenBookmarkEditor()
{
  var sUrl = sSetParameter(ACT_PARAM_NAM, sEncodeURI(_sDefaultBookmarkName), "<#AddBookmarkURL noname="1">");
  sUrl = sGetBookmarkURL(sUrl); // add dynamic state to bookmark URL
  OpenWindow(sUrl, "_blank", iGetBookmarkEditorWidth(), iGetBookmarkEditorHeight(), 0);
}

function sUpdateDefaultBookmarkName(vsDefaultBookmarkName, vbRecursing)
{
  var oFrameset;
  if (!vbRecursing) {
    oFrameset = oGetDetailsPaneFrameset(parent);
    if (!oFrameset || !oFrameset.sUpdateDefaultBookmarkName)
      oFrameset = oGetInformationViewFrame();
  }

 if (oFrameset && oFrameset.sUpdateDefaultBookmarkName)
   vsDefaultBookmarkName = oFrameset.sUpdateDefaultBookmarkName(vsDefaultBookmarkName, true);
  else {
    if (!vsDefaultBookmarkName) {
      if (!vsDefaultBookmarkName && (typeof(sGetBookmarkDefaultName) === "function"))
        vsDefaultBookmarkName = sGetBookmarkDefaultName();

      if (!vsDefaultBookmarkName && (typeof(sGetViewName) === "function")) {
        vsDefaultBookmarkName = sGetViewName();
        if (vsDefaultBookmarkName)
          vsDefaultBookmarkName = HTMLEscapeToURLEscape(vsDefaultBookmarkName);
      }

      if (!vsDefaultBookmarkName)
        vsDefaultBookmarkName = '<#ViewName ENC="url">';
    }
  }

  if (vsDefaultBookmarkName)
    _sDefaultBookmarkName = vsDefaultBookmarkName;

  return _sDefaultBookmarkName;
}

function sGetBookmarkButton(vsDefaultBookmarkName, vbExcludeTableCells)
{
  if (<#IsPortalReadonly true="true" false="false"> && !<#EnableBookmarksForViewUsers true="true" false="false">)
    return "";

  sUpdateDefaultBookmarkName(vsDefaultBookmarkName);

  var sHREF;
  if (bInPortal())
    sHREF = "javascript:oGetInformationView().OpenBookmarkEditor()";
  else
    sHREF = "javascript:OpenBookmarkEditor()";

  var sName = "<#LocalizedText id="Bookmark">";

  if (vbExcludeTableCells)
    return sGetButtonHTML(sName, sHREF);
  else
    return sGetToolbarIconButtonHTML(sName, sHREF, "<#PortalImageFileLocation>icon_star.png");
}

function sGetAlternateBookmarks()
{
  return sDecodeURI("<#AlternateBookmarks>");
}

function sGetBookmarkModelId()
{
  return sDecodeURI("<#BookmarkModelId>");
}

function sGetAddToBasketButton(vsDefaultBookmarkName, vbExcludeTableCells)
{
  if (<#HasRights product="portal" level="update" false="true" true="false">)
    return "";

  sUpdateDefaultBookmarkName(vsDefaultBookmarkName);

  var sHREF = "javascript:OpenWindow(\"<#VTNViewURL VTN="selectbasketitems" CRP="p">\", \"BasketView\", " + iGetBasketViewWidth() + ", " + iGetBasketViewHeight() + ")";
  var sName = "<#LocalizedText id="Add to Basket">";
  if (vbExcludeTableCells)
    return sGetButtonHTML(sName, sHREF);
  else
    return sGetToolbarIconButtonHTML(sName, sHREF, "<#PortalImageFileLocation>icon_add_to_basket.png");
}

function bGetBasketItems(AddView, AddDataItem, AddElement, AddBriefingItem)
{
  var oFrameset = oGetDetailsPaneFrameset(parent);
  if (oFrameset && oFrameset.bGetBasketItems)
    return oFrameset.bGetBasketItems(AddView, AddDataItem, AddElement, AddBriefingItem);
  return bGetBasketItemsEx(AddView, AddDataItem, AddElement, AddBriefingItem, "<#BasketItems enc="js">", _sDefaultBookmarkName);
}

function sGetDefaultToolbarButtons(vsDefaultBookmarkName, vsAdditionalToolbarHTML)
{
  if ((typeof(sGetBookmarkButton) != "undefined") && (typeof(sGetAddToBasketButton) != "undefined"))
    return sGetBookmarkButton(vsDefaultBookmarkName) +
           sGetAddToBasketButton(vsDefaultBookmarkName) +
           (vsAdditionalToolbarHTML ? vsAdditionalToolbarHTML : "");
  else 
    return "";
}

function sGetActionsButton()
{
  var oMainView = oGetMainView();
  if (oMainView && oMainView.bIsLicensedActions())
    return sGetToolbarIconButtonHTMLForOpenInformationView("<#LocalizedText id="Actions">", "<#AttachURL>", "<#PortalImageFileLocation>icon_actions.png");
  else
    return "";
}

function sGetDefaultToolbarButtonsWithActions(vsDefaultBookmarkName, vsAdditionalToolbarHTML)
{
  return sGetDefaultToolbarButtons(vsDefaultBookmarkName, sGetActionsButton() + (vsAdditionalToolbarHTML ? vsAdditionalToolbarHTML : ""));
}

</script>
<!-- [QPRTemplateEnd: jsportaltoolbarutils.tpl] -->
