<!-- [QPRTemplateStart: tabledesigner.tpl] -->
<script type="text/javascript" src="<#CommonScriptFileLocation>toolframeutils.js"></script>

<#Include template="jswsfutils.tpl">
<#Include template="jsworkflowutils.tpl">

<script type="text/javascript">
function ProcessModelVersionOptions()
{
  var oHierarchyTree = oGetHierarchyTreeView();
  if ((oHierarchyTree) && (typeof(oHierarchyTree.arGetModelVersionOptions) != "undefined")) {
    var arModelVersionOptions = oHierarchyTree.arGetModelVersionOptions();
    if (arModelVersionOptions) {
      document.write('<tr><td>');
      var sCaption = arModelVersionOptions.pop();
      document.write(sCaption);
      document.write('<br />');
      for (var i = 0; i < arModelVersionOptions.length; ++i) {
        var sInput = '<input type="radio" name="ModelVersionOption"';
        sInput += ' value="' + arModelVersionOptions[i].sValue + '" onclick="OnViewSettingsChanged()" />&nbsp;' + arModelVersionOptions[i].sName;
        document.write(sInput);
        document.write('<br />');
      }
      document.write('</td></tr>');
    }
  }
}

function bOpenPrintView(vsPrintViewURL)
{
  var sUrl = sGetDocumentLocation(),
      oInfoView = oGetInformationView(),
      oInfoViewFrame = oGetInformationViewFrame(),
      sWindowName = 'PrintWindow' + (new Date()).getTime();
  if ( oInfoView.sAddDynamicState || oInfoViewFrame.sAddDynamicState )
    sUrl = (oInfoView.sAddDynamicState ||
            oInfoViewFrame.sAddDynamicState)(sUrl);
  sUrl = sSetParameter("PRN", "PRINT", sUrl);

  PromptPrintingMode(function() {
    if (typeof(sGetExpandedNodes) === "function")
      sUrl = sSetParameter(ACT_PARAM_EXPANDED_NODES, sGetExpandedNodes(), sUrl);
    else
      sUrl = sSetParameter(ACT_PARAM_HIERARCHY_EXPAND_ALL, '1', sUrl);

    sUrl = sSetParameter("URL", sEncodeURI(sUrl), vsPrintViewURL);
    OpenWindow(oGetMainView()._sEmptyPage, sWindowName, 900, 600, 1);
    OpenViewDirectly(sUrl, sWindowName);
  }, function() {
    sUrl = sSetParameter(ACT_PARAM_HIERARCHY_EXPAND_ALL, '1', sUrl);
    sUrl = sSetParameter(ACT_PARAM_MAX_ROWS,
                         window._iTotalMatchCount ||
                         (oInfoView.iGetTotalMatchCount ||
                          oInfoViewFrame.iGetTotalMatchCount)(),
                         sUrl);
    sUrl = sSetParameter(ACT_PARAM_FIRST_INDEX, '0', sUrl);
    sUrl = sSetParameter("URL", sEncodeURI(sUrl), vsPrintViewURL);
    OpenWindow(oGetMainView()._sEmptyPage, sWindowName, 900, 600, 1);
    OpenViewDirectly(sUrl, sWindowName);
  });
  return true;
}

function PromptPrintingMode(voPrintCurrent, voPrintAll)
{
  var oMainView = oGetMainView(), oButtons = {}, $;
  if ( !oMainView )
    voPrintCurrent();
  $ = oMainView.$;

  oButtons[sDecodeURI('<#LocalizedTextMessage id="Current page">')] =
    function() {
      $(this).dialog('close');
      voPrintCurrent();
    };
  oButtons[sDecodeURI('<#LocalizedTextMessage id="All pages">')] =
    function() {
      $(this).dialog('close');
      voPrintAll();
    };

  if ( bIsRTL() ) { // Switch the buttons the other way around.
    var slLabels = [], oNewButtons = {}, i;
    for ( i in oButtons ) slLabels.unshift(i);
    for ( i in slLabels ) oNewButtons[i] = oButtons[i];
    oButtons = oNewButtons;
  }

  $('<div>').text(sDecodeURI('<#LocalizedTextMessage id="Print current page or all pages?">'))
            .dialog({
    title: sDecodeURI('<#LocalizedTextMessage id="Select printing mode">'),
    buttons: oButtons,
    minHeight: 10,
    minWidth: 10,
    resizable: false
  });
}
</script>

<div id="divtabledesigner" style="display: none">
  <form name="formTableDesigner" action="" method="post">
    <div id="PropertyListWrapper" class="PropertyList">
      <table cellpadding="0" cellspacing="0" class="PropertyForm">
			  <caption style="border-top: 0;"><#LocalizedText id="View Designer"></caption>
				<tr>
					<th style="width: 270px; font-weight: normal; padding-left: 20px;"><#LocalizedText id="Select Fields"></th>
					<th style="font-weight: normal; padding-left: 20px;"><#LocalizedText id="Field Properties"></th>
				</tr>
				<tr>
					<td>
            <select name="lstSelectedFields" size="10" style="width: 150px; float: left;" multiple="multiple" onChange="OnFieldChanged();">
            </select>
						
            <div class="ButtonColumn">
              <input type="button" name="btnAdd" value="<#LocalizedText id="Add...">" onclick="OnAdd()" style="width: 100px" />
              <input type="button" name="btnRemove" value="<#LocalizedText id="Remove">" onclick="OnRemove()" style="width: 100px" /><br />
              <input type="button" name="btnUp" value="<#LocalizedText id="Up">" onclick="OnUp()" style="width: 100px" /><br />
              <input type="button" name="btnDown" value="<#LocalizedText id="Down">" onclick="OnDown()" style="width: 100px" />
            </div>
          </td>
          <td style="vertical-align: top;">
            <div id="divsinglefield">
              <table border="0" cellspacing="0" cellpadding="0">
                <tr>
                  <td style="vertical-align: top;">
                    <table border="0" cellspacing="0" cellpadding="0">
                      <tr id="trWidthConfig">
                        <td>
                          <table cellspacing="0" cellpadding="0">
                            <tr>
                              <td>
                                <#LocalizedText id="Column width:">
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <input type="radio" name="radWidthType" value="0" onClick="OnColumnWidthTypeChanged(); OnViewSettingsChanged();">&nbsp;<#LocalizedText id="Relative width">
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <input type="radio" name="radWidthType" value="1" onClick="OnColumnWidthTypeChanged(); OnViewSettingsChanged();">&nbsp;<#LocalizedText id="Fixed width">&nbsp;
                                <input type="text" name="txtFixedColumnWidth" value="" onChange="OnViewSettingsChanged();" size="3" maxlength="3">
                              </td>
                            </tr>
                          </table>
                        </td>
                      </tr>
                      <tr>
                        <td>
                          <table border="0" cellspacing="0" cellpadding="0">
                            <tr>
                              <td>
                                <#LocalizedText id="Column header text:">
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <select name="cbxColumnHeaderText" onChange="OnColumnHeaderTypeChanged(); OnViewSettingsChanged();" size="1" style="width: 100px">
                                </select>
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <input type="text" name="txtColumnHeaderText" onChange="OnViewSettingsChanged();" value="" style="width: 100px">
                              </td>
                            </tr>
                          </table>
                        </td>
                      </tr>
                    </table>
                  </td>
                  <td style="vertical-align: top;">
                    <div id="divCustomAttributefieldcustomization" style="display: none">
<#Include template="customattributeselection.tpl">
                    </div>
                    <div id="divmeasurevaluefieldcustomization" style="display: none">
<#Include template="measureseriesandperiodselection.tpl">
                    </div>
                    <div id="divworkflowfieldcustomization" style="display: none">
                      <table id="tableWorkflowSelection" width="100%" border="0" cellspacing="0" cellpadding="0" style="display: none">
                        <tr>
                          <td>
                            <#LocalizedText id="Workflow">:
                          </td>
                        </tr>
                        <tr>
                          <td>
                            <select name="cbxAvailableWorkflows" onChange="OnViewSettingsChanged();" size="1"></select>
                          </td>
                        </tr>
                      </table>
                      <table width="100%" border="0" cellspacing="0" cellpadding="0">
                        <tr>
                          <td>
                            <#LocalizedText id="Trigger parameter">:
                          </td>
                        </tr>
                        <tr>
                          <td>
                            <input type="text" name="txtTriggeringParameter" value="" />
                          </td>
                        </tr>
                      </table>
                    </div>
                    <div id="divactionfieldcustomization" style="display: none">
                      <table border="0" cellspacing="0" cellpadding="0">
                        <tr>
                          <td>
                            <#LocalizedText id="Show">
                          </td>
                        </tr>
                        <tr>
                          <td>
                            <select name="cbxActionTimespan" onChange="OnActionTimespanChanged(); OnViewSettingsChanged();" size="1" style="width: 200px">
                            </select>
                          </td>
                        </tr>
                        <tr>        
                          <td>
                            <table border="0" cellspacing="0" cellpadding="0">
                              <tr>
                                <td>
                                  <input type="text" name="txtActionNumPeriodsBefore" value="" size="3" maxlength="3" />&nbsp;
                                </td>
                                <td>
                                  <#LocalizedText id="periods before the selected period.">
                                </td>
                              </tr>
                              <tr>
                                <td>
                                  <input type="text" name="txtActionNumPeriodsAfter" value="" size="3" maxlength="3" />&nbsp;
                                </td>
                                <td>
                                  <#LocalizedText id="periods after the selected period.">
                                </td>
                              </tr>
                            </table>
                          </td>
                        </tr>
                        <tr>
                          <td>
                            <input type="checkbox" value="0" name="chkRecursiveActions">
                            <#LocalizedText id="Drill through actions">
                          </td>
                        </tr>
                      </table>
                    </div>
                    <div id="divpgactionfieldcustomization" style="display: none">
                      <table cellspacing="0" cellpadding="0">
                        <tr>
                          <td>
                            <input type="checkbox" value="0" name="chkPGRecursiveActions">
                            <#LocalizedText id="Drill through actions">
                          </td>
                        </tr>
  <#Include template="modelversionselection.tpl">
                      </table>
                    </div>
                  </td>
                </tr>
              </table>
            </div>
          </td>
        </tr>
      </table>
      <table cellpadding="0" cellspacing="0" class="PropertyForm">
				<tr>
					<th style="width: 220px; font-weight: normal; padding-left: 20px;"><#LocalizedText id="Other Settings"></th>
					<th style="font-weight: normal; padding-left: 20px;"><#LocalizedText id="Filters"></th>
				</tr>
				<tr>
				  <td>
            <div id="othersettings1">
              <table border="0" cellspacing="0" cellpadding="2">
                <tr>
                  <td id="othersettings2">
                    <input type="checkbox" value="0" id="Recursive2" name="Recursive" onClick="OnViewSettingsChanged();">
                    <#LocalizedText id="Drill through information items">
                   </td>
                </tr>
                <tr>
                  <td>
                    <input type="checkbox" value="0" id="Recursive1" name="Recursive" onClick="OnViewSettingsChanged();">
                    <script type="text/javascript">if (typeof(sGetDrillThroughCaption) === "function") sGetDrillThroughCaption()</script>
                  </td>
                </tr>
<script type="text/javascript">
  ProcessModelVersionOptions();
</script>
              </table>
            </div>
          </td>
          <td>
            <span id="txtConditions"></span>
          </td>
				</tr>
		  </table>
		</div>
		<div class="ButtonRow" style="border-bottom: 2px solid #a3c0dc;">
      <input type="button" name="btnConfigureFilters" value="<#LocalizedText id="Configure Filters...">" onclick="OnConfigureFilters()" style="width: 160px; float: left;" />
      <input type="button" name="btnHelp" value="<#LocalizedText id="Help">" style="width: 160px; float: right;" onclick="javascript: OnTableDesignerHelp();" />
<script type="text/javascript">
  if (bIsNativeView() && (!sGetParameter("BOOKMARK", sGetDocumentLocation())) && <#IsPortalReadonly true="false" false="true">) {
    if (<#HasRights product="portal" level="admin" true="true" false="false">)
      document.write('<input type="button" name="btnSetAsDefault" value="<#LocalizedText id="Set as Default...">" onclick="OnSetAsDefaultViewSetting()" style="width: 160px; float: right;" />');
    else
      document.write('<input type="button" name="btnSetAsDefault" value="<#LocalizedText id="Set as Default">" onclick="OnSetAsDefaultViewSetting()" style="width: 160px; float: right;" />'); 
  }

  if (<#IsPortalReadonly true="false" false="true">)
    document.write('<input type="button" name="btnSave" value="<#LocalizedText id="Save...">" onclick="OnSaveSettings()" style="width: 160px; float: right;" />');
</script>
      <input type="button" name="btnApply" value="<#LocalizedText id="Apply">" onclick="OnApply()" style="width: 160px; float: right;" />
    </div>
  </form>
  <div class="Clearer"></div>

  <div class="PropertyList">
    <table cellpadding="0" cellspacing="0">
      <caption style="border-top: 0">
<script type="text/javascript">
  document.write(URLEscapeToHTMLEscape(sGetRootName()));
</script>
      </caption>
    </table>
  </div>
  <iframe style="display: none" id="ExportFrame" name="ExportFrame" src="<#PageFileLocation>empty.html">
  </iframe>
</div>

<script type="text/javascript" src="<#CommonScriptFileLocation>tabledesigner.js"></script>    

<script type="text/javascript">
InitShowState();

var _OQAttribute = "<#Parameter id="OQ_attribute">";

function sGetDesignerButtonHTML()
{
  var oMainView = oGetMainView();

  var sResult = sGetToolbarIconButtonHTML("<#LocalizedText id="Views">", "javascript:oGetInformationViewFrame().OpenViewSettings()", "<#PortalImageFileLocation>icon_view_selection.png");
  if ((<#HasRights product="portal" level="update" true="true" false="false">) &&
      !bHideTableDesigner()) {
    if (_bDesignerShown)
      sResult = sGetToolbarIconButtonHTML("<#LocalizedText id="Hide Designer">", "javascript:oGetInformationViewFrame().ToggleDesigner()", "<#PortalImageFileLocation>icon_hide_designer.png") + sResult;
    else
      sResult = sGetToolbarIconButtonHTML("<#LocalizedText id="Show Designer">", "javascript:oGetInformationViewFrame().ToggleDesigner()", "<#PortalImageFileLocation>icon_show_designer.png") + sResult;
  }  
  
  if ( oMainView && oMainView.bIsLicensedExcelExport() &&
       (!oMainView.bIsLicensedPowerPointExport() ||
        <#HasRights product="portal" level="update" true="false" false="true">) ) {
    if ( oGetInformationViewFrame && oGetInformationViewFrame() &&
         oGetInformationViewFrame().ExcelExport && !IPAD )
      sResult += sGetToolbarIconButtonHTML("<#LocalizedText id="Export to Excel">", "javascript:oGetInformationViewFrame().ExcelExport()", "<#PortalImageFileLocation>icon_excel_export.png");
  } else if ( oMainView && oMainView.bIsLicensedPowerPointExport() ) {
    if ( oGetInformationViewFrame && oGetInformationViewFrame() &&
         oGetInformationViewFrame().OfficeExport && !IPAD )
      sResult += sGetToolbarIconButtonHTML("<#LocalizedText id="Export to Office">", "javascript:oGetInformationViewFrame().OfficeExport()", "<#PortalImageFileLocation>icon_office.png");
  }
  return sResult;
}

function OfficeExportToolFrame() { var t; return (t = $.extend(ToolFrame(), {
  sGetHeaderHTML: function() {
    return '<h1>' + sDecodeURI('<#LocalizedTextMessage id="Export to Office">') + '</h1>';
  },

  sGetContentHTML: function() {
    var sLocation = sGetBaseURL('QPRPORTAL', ACT_COM_TABLE_VIEW);
    sLocation = sSetParameter(ACT_PARAM_TEMPLATE, 'officeexportview.tpl',
                              sLocation);
    sLocation = sAddUIPOrSession(sLocation);

    return '<iframe name="OfficeExportView" id="OfficeExportView" '
         + 'src="' + sLocation + '" marginheight="0" '
         + 'marginwidth="0" frameborder="0">'
         + '</iframe>';
  }
}));}

$.extend(OfficeExportToolFrame, ToolFrame)
 .ToolFrame = OfficeExportToolFrame;


function AnalysisPowerPointExporter(voCallback, voErrorCallback,
                                    vsSlideshowId, vsTemplateId) {
  var t; return(t = $.extend(WSFUtils(),
{
  sExcelExportURL: null,
  sXML: null,


  Process: function(vsExcelExportURL)
  {
    t.sExcelExportURL = vsExcelExportURL;
    t.LoadProxy(t.FetchURL, t.HandleError);
  },


  FetchURL: function()
  {
    var oFrame, sURL;
    sURL = sSetParameter('NOEXCEL', '1', t.sExcelExportURL);

    window.ProcessExportData = function(vsData) {
      // setTimeout() so that we can remove the frame without IE going kaboom
      // because the calling function's frame just vanished
      setTimeout(function() {
        window.ProcessExportData = null;
        oFrame.remove();
        oFrame = null;
        t.SerializeXML(vsData);
      }, 1);
    };

    (oFrame = $('<iframe/>'))
      .css({ width: '0px', height: '0px', display: 'none' })
      .appendTo($(oGetBodyFromDocument(document)))
      .attr('src', sURL);
  },


  SerializeXML: function(vsData)
  {
    var oInformationView = oGetInformationView();
    var oContainer = $('<div><table/></div>');
    oContainer.children().html(vsData);
    var sName = null;

    if ( oInformationView )
      if ( oInformationView.sGetHeaderViewLeftHTML )
        sName = sHTMLDecode(oInformationView.sGetHeaderViewLeftHTML());
      else if ( oInformationView.sGetViewName )
        sName = oInformationView.sGetViewName();
    if ( !sName )
      sName = 'Analysis';

    // Serialize the table into simple XML
    var sXML = '<table><viewname><![CDATA[' + 
               sName.replace(/\]\]>/, ']] >') +
               ']]></viewname>';

    var olRows = oContainer.find('tbody').eq(0).children();
    var oHandleTable;

    olRows.each(
      oHandleTable = function (viIndex) {
        sXML += '<tr>';
        var olCells = olRows.eq(viIndex).children();
  
        olCells.each(
          function (viIndex) {
            var oCell = olCells.eq(viIndex);
            if ( oCell.find('table').length > 0 ) {
              var olPreviousRows = olRows;
              olRows = oCell.find('tbody').eq(0).children();
  
              sXML += '<td><table>';
              olRows.each(oHandleTable);
              sXML += '</table></td>';
              olRows = olPreviousRows;
            } else {
              var sText = olCells.eq(viIndex).text();
              sText = sText.replace(/\]\]>/, ']] >');
              sXML += '<td><![CDATA[' + sText + ']]></td>';
            }
          }
        );
        sXML += '</tr>';
      }
    );

    sXML += '</table>\r\n';

    t.sXML = sXML;
    t.AutoAuthenticate(t.GenerateSlideShow, t.HandleError);
  },


  GenerateSlideShow: function()
  {
    t.oClient.PowerPointAddSlides(
      t.sSessionId,
      vsSlideshowId,
      vsTemplateId,
      t.oCreateTypedArray([t.sXML]),
      t.oCreateTypedArray(['analysis']),
      t.oCreateTypedArray(['']),
      t.GetSlideShow, t.HandleError);
  },


  GetSlideShow: function(vbGenerated)
  {
    t.LogOff(voCallback, voCallback);
  },


  HandleError: function(voError)
  {
    var sError = t.sGetStringFromError(voError),
        oReport = function() { voErrorCallback(sError); };

    if ( t.oClient && t.sSessionId )
      t.LogOff(oReport, oReport);
    else
      oReport();
  }
}
  ));
}

function sGetExportURL(vsTemplate)
{
  var sUrl = sGetDocumentLocation();
  sUrl = sSetParameter(ACT_PARAM_TEMPLATE, vsTemplate, sUrl);
  sUrl = sSetParameter("EXATTR", _OQAttribute, sUrl);
  sUrl = sSetParameter("EXCFG", "<#Parameter id="OQ_configuration">", sUrl);
  sUrl = sSetParameter("EXSORT", "<#Parameter id="OQ_sort">", sUrl);
  sUrl = sSetParameter("EXFIELDS", "<#Parameter id="OQ_fields">", sUrl);
  sUrl = sSetParameter("EXTPLGROUP", "<#Parameter id="OQ_templategroup">", sUrl);
  sUrl = sSetParameter("EXDECSEP", (1.5).toLocaleString().charAt(1), sUrl);
  
  sUrl = sRemoveParameter("FIRST", sUrl);
  return sUrl;
}


function PowerPointExport(voCallback, voErrorCallback, vsSlideshowId,
                          vsTemplateId, voOptions)
{
  AnalysisPowerPointExporter(voCallback, voErrorCallback,
                             vsSlideshowId, vsTemplateId)
    .Process(sGetExportURL("analysisview_excelexport.tpl"));
}


function OfficeExport()
{
  OfficeExportToolFrame.ToggleVisibility();
}

function ExcelExport()
{
  var sUrl = sGetExportURL("analysisview_excelexport.tpl")
  sUrl = sAddUIPOrSession(sUrl);
  if (IEANY)
    sUrl = sSetPathInfo("/qprexport_" + (new Date()).getTime() + ".xls", sUrl);
  else
    sUrl = sSetPathInfo("/qprexport.xls", sUrl);

  OpenWindow(sUrl, "ExportFrame");
}

function OpenViewSettings()
{
  var oHeaderView = oGetHeaderView();
  if (oHeaderView) {
    var sUrl = "<#TableViewURL plugin="QPRPORTAL">";
    sUrl = sSetParameter(ACT_PARAM_TEMPLATE, "viewsettingsselectionview.tpl", sUrl);
    sUrl = sSetParameter(ACT_PARAM_QUERY_ROOT_SHORT, sEncodeURI(sGetViewSettingGroup() + "&"), sUrl);
    OpenWindow(sUrl, "FieldSelection", 400, 300, true, true);
  }
}

 
function OnAdd()
{
  var sUrl = "<#FramedPageURL CRP="p" template="objectselection.tpl">";
  OpenWindow(sUrl, "FieldSelection", 400, 300, false, true);
}

function arGetSelectableObjects()
{
  var arFields = arGetTableFields();
  var arResult = [];
  for (var i = 0; i < arFields.length; ++i) {
    var oField = arFields[i];
    arResult[arResult.length] = {
      "psId" : oField.psAlias,
      "psName" : oField.sGetLabel()
    };
  }
  return arResult;
}

function OnDeleteElementEventHandler(result, data) 
{
  var adata = data.split("|");
    
  if (result == "ERROR") {
    if (adata[1].length > 0)
      window.alert(adata[1]);
  } else if (result == "CONFIRM") {
      if (confirm(adata[1]))      
        OnDelete(adata[0], false); 
  } else if (result == "OK")  
    OnApply();
}

function OnDelete(fullid, bCheck)
{
  var sUrl = "<#DeleteUrl>"; 
  sUrl += "&OBJ=" + fullid;
  if (bCheck == true)
    sUrl += "&CHK=1";   
  CallServerFunction(sUrl, OnDeleteElementEventHandler);
}

function OnConfigureFilters()
{
  _sFilterDesignerDefaultField = "";
  var sUrl = "<#FramedPageURL CRP="p" template="tablefilterdesigner.tpl">";
  OpenWindow(sUrl, "FilterDesigner", 655, 450, false, true);
}

function OnSaveSettings()
{
  var oHeaderView = oGetHeaderView();
  if (oHeaderView) {
    SaveFieldCustomizations(document.formTableDesigner);
    UpdateControlStates();

    var sUrl = "<#AddBookmarkURL noname="1">";
    sUrl = sSetParameter(ACT_PARAM_TEMPLATE, "viewsettingseditorview.tpl", sUrl);
    var sSettings = sSetParameter(ACT_PARAM_QUERY_FIELDS_SHORT, sGetFields(), sEncodeURI(sGetViewSettingGroup()));
    sSettings = sSetParameter(ACT_PARAM_QUERY_FILTERS_SHORT, sGetFilters(), sSettings);
    var sSortBy = sGetCurrentSortBy();
    if (sSortBy)
      sSettings = sSetParameter(ACT_PARAM_QUERY_SORT_BY_SHORT, sSortBy, sSettings);
    if (typeof(sGetViewSettingsParameters) != "undefined")
      sSettings = sGetViewSettingsParameters(sSettings);
    sSettings = sSetParameter(ACT_PARAM_RECURSIVE, sGetRecursive(), sSettings);
    sSettings = sSetParameter(ACT_PARAM_MODEL_VERSIONS, sGetModelVersionsOption(), sSettings);
    sUrl = sSetParameter(ACT_PARAM_URL, sEncodeURI(sSettings), sUrl);
    OpenWindow(sUrl, "_blank", iGetBookmarkEditorWidth(), iGetBookmarkEditorHeight(), 0);
  }
}

function OnSaveSettingsOk()
{
  OnApply();
}

function FoGetFirstSelectedField()
{
  var arOptions = document.formTableDesigner.lstSelectedFields.options;

  for (var i = 0; i < arOptions.length; ++i) {
    var oOption = arOptions[i];
    if (oOption.selected)
      return _arSelectedFields[i];
  }
}

function FSelectColumnHeaderItemByHeaderType(viType)
{
  var cbxColumnHeaderText = document.formTableDesigner.cbxColumnHeaderText;
  for (var i = 0; i < cbxColumnHeaderText.length; ++i) {
    var oOption = cbxColumnHeaderText.options[i];
    if (oOption.value == viType) {
      cbxColumnHeaderText.selectedIndex = i;
      return;
    }
  }
  cbxColumnHeaderText.selectedIndex = -1;
}

function FbShowOtherSettings()
{
  if (typeof(bShowOtherSettings) != "undefined")
    return bShowOtherSettings();
  var oRecursive1 = document.getElementById('Recursive1');
  return _bDesignerShown && (oRecursive1.value != "0");
}

function UpdateControlStates(vbFieldChanged)
{
  var oDesigner = document.getElementById('divtabledesigner');
  if (_bDesignerShown)
    oDesigner.style.display = "block";
  else
    oDesigner.style.display = "none";

  var oOtherSettings = document.getElementById('othersettings1');

  if (FbShowOtherSettings()) {
    oOtherSettings.style.display = "block";  

    var oOtherSettings2 = document.getElementById('othersettings2');
    var oRecursive2 = document.getElementById('Recursive2');

    if (oRecursive2.value != "0")
      oOtherSettings2.style.display = "block";
    else
      oOtherSettings2.style.display = "none";
  }
  else
    oOtherSettings.style.display = "none";  

  var lstSelectedFields = document.formTableDesigner.lstSelectedFields;
  document.formTableDesigner.btnRemove.disabled = (lstSelectedFields.selectedIndex < 0);

  var bDisabled = true, bNonSelectedFound = false, arOptions = lstSelectedFields.options;
  for (var i = 0; i < arOptions.length; ++i) {
    var oOption = arOptions[i];
    if (bNonSelectedFound && (oOption.selected)) {
      bDisabled = false;
      break;
    }
    else if (!bNonSelectedFound && (!oOption.selected))
      bNonSelectedFound = true;
  }
  document.formTableDesigner.btnUp.disabled = bDisabled;

  bDisabled = true;
  bNonSelectedFound = false;
  var iShownCount = 0;
  for (var i = arOptions.length - 1; i >= 0; --i) {
    var oOption = arOptions[i];
    if (bDisabled) {
      if (bNonSelectedFound && (oOption.selected))
        bDisabled = false;
      else if (!bNonSelectedFound && (!oOption.selected))
        bNonSelectedFound = true;
    }
    if (oOption.selected)
      ++iShownCount;
  }
  document.formTableDesigner.btnDown.disabled = bDisabled;

  if (_oPrevShownFieldCustomizationDiv)
    _oPrevShownFieldCustomizationDiv.style.display = "none";

  _oSelectedField = FoGetFirstSelectedField();
  var sFieldCustomization = _oSelectedField ? _oSelectedField.sGetFieldCustomizationMode() : "";

  oDiv = document.getElementById('divsinglefield');
  if (iShownCount == 1) {
    oDiv.style.display = "block";
    _bSingleFieldEditShown = true;
    if (sFieldCustomization && (sFieldCustomization != "")) {
      if (sFieldCustomization == "measurepath")
        oDiv = document.getElementById('divmeasurevaluefieldcustomization');
      else if (sFieldCustomization == "workflowforworkflowticket")
        oDiv = document.getElementById('divworkflowfieldcustomization');
      else
        oDiv = document.getElementById('div' + sFieldCustomization + 'fieldcustomization');
      if (oDiv) {
        oDiv.style.display = "block";
        _oPrevShownFieldCustomizationDiv = oDiv;
        eval("FUpdate" + sFieldCustomization + "ControlStates()");
      }
    }
  }
  else {
    oDiv.style.display = "none"; 
    _bSingleFieldEditShown = false;
  }

  var lblConditions = document.getElementById('txtConditions');
  if (_arFilters.length == 0) {
    lblConditions.innerHTML = '<#LocalizedText id="Show all">';
  }
  else {
    var sHTML = "";
    for (var i = 0; i < _arFilters.length; ++i) {
      if (i > 0) 
        sHTML += "<br />";
      var oFilter = _arFilters[i];
      sHTML += "<img class='JSTreeImage' src='<#ImageFileLocation>icon_filter.gif' />&nbsp;" + sHTMLEncode(oFilter.sGetLabel());
    }
    lblConditions.innerHTML = sHTML;
  }

  if (_oSelectedField) {
    var arOptions = document.formTableDesigner.cbxColumnHeaderText.options;
    arOptions.length = 0;
    arOptions[arOptions.length] = new Option(sDecodeURI("<#LocalizedText id="None" enc="js">"), CHT_NONE); 
    arOptions[arOptions.length] = new Option(sDecodeURI("<#LocalizedText id="Field name" enc="js">"), CHT_DEFAULT); 
    arOptions[arOptions.length] = new Option(sDecodeURI("<#LocalizedText id="Custom header" enc="js">"), CHT_CUSTOM);

    if (sFieldCustomization && (sFieldCustomization != ""))
      eval("if (typeof(GetColumnHeaderOptionsFor" + sFieldCustomization + ") != 'undefined') GetColumnHeaderOptionsFor" + sFieldCustomization + "();");
    
    FSelectColumnHeaderItemByHeaderType(_oSelectedField.iGetColumnHeaderType());
    document.formTableDesigner.txtColumnHeaderText.value = _oSelectedField.sGetColumnHeaderText();
    OnColumnHeaderTypeChanged();
    var iFixWidth = _oSelectedField.iGetFixedWidth();
    document.formTableDesigner.radWidthType[(iFixWidth > 0) ? 1 : 0].checked = true;
    if (iFixWidth <= 0)
      document.formTableDesigner.txtFixedColumnWidth.value = 100;
    else
      document.formTableDesigner.txtFixedColumnWidth.value = iFixWidth;
  }

  OnColumnWidthTypeChanged();
}


function GetColumnHeaderOptionsFormeasurevalue()
{
  var arOptions = document.formTableDesigner.cbxColumnHeaderText.options;
  arOptions[arOptions.length] = new Option(sDecodeURI("<#LocalizedText id="Period name" enc="js">"), CHT_PERIOD);  
  arOptions[arOptions.length] = new Option(sDecodeURI("<#LocalizedText id="Series name" enc="js">"), CHT_SERIES);  
}


function sGetObjectSelectionOkLabel()
{
  return "<#LocalizedText id="Add">";
}

function sGetObjectSelectionTitle()
{
  return "<#LocalizedText id="Add Table Fields">";
}

function OnObjectSelectionHelp()  
{
  OpenHelpWindow(sDecodeURI('<#HelpURL>?shared_fieldselectionview.htm'));
}

function OnConfigureFieldFilter(voField)
{
  _bDesignerShown = true;

  UpdateControlStates();
  var oMainView = oGetMainView();
  if (oMainView && oMainView.RefreshToolbar)
    oMainView.RefreshToolbar();

  _oFilterDesignerDefaultField = voField;
  var sUrl = "<#FramedPageURL CRP="p" template="tablefilterdesigner.tpl">";
  OpenWindow(sUrl, "FilterDesigner", 400, 300, false, true);
}

function OnTableDesignerHelp()
{
  OpenHelpWindow(sDecodeURI('<#HelpURL>?shared_tabledesignerview.htm'));
}

function OnSetAsDefaultViewSetting()
{
  if (<#HasRights product="portal" level="admin" true="true" false="false">) {
    var sUrl = "<#FramedPageURL CRP="p" template="setasdefaultviewsettingsview.tpl">";
    OpenWindow(sUrl, "SetAsDefaultViewSettings", 400, 300, false, true);
  }
  else {
    SetAsDefault(null, function(vsURL, vsParams) {
      $.post(vsURL, vsParams);
    });
  }
}

function FUpdateactionControlStates(vbFieldChanged)
{
  var arOptions = document.formTableDesigner.cbxActionTimespan.options;
  arOptions.length = 0;
  arOptions[arOptions.length] = new Option(sDecodeURI("<#LocalizedText id="All actions" enc="js">"), arOptions.length); 
  arOptions[arOptions.length] = new Option(sDecodeURI("<#LocalizedText id="Actions created" enc="js">"), arOptions.length); 
  arOptions[arOptions.length] = new Option(sDecodeURI("<#LocalizedText id="Actions modified" enc="js">"), arOptions.length);
  arOptions[arOptions.length] = new Option(sDecodeURI("<#LocalizedText id="Set dates of actions are" enc="js">"), arOptions.length);                               
  var iTimespanType = _oSelectedField.sGetFieldCustomization(0);
  if (!iTimespanType)
    iTimespanType = 0;
  document.formTableDesigner.cbxActionTimespan.selectedIndex = iTimespanType;
  var iBefore = _oSelectedField.sGetFieldCustomization(1);
  if (!iBefore)
    iBefore = 0;
  document.formTableDesigner.txtActionNumPeriodsBefore.value = iBefore;
  var iAfter = _oSelectedField.sGetFieldCustomization(2);
  if (!iAfter)
    iAfter = 0;
  document.formTableDesigner.txtActionNumPeriodsAfter.value = iAfter;
  OnActionTimespanChanged();
  if (_oSelectedField.sGetFieldCustomization(3) == "0")
    document.formTableDesigner.chkRecursiveActions.checked = false;
  else
  {
    _oSelectedField.SetFieldCustomization(3, "1");
    document.formTableDesigner.chkRecursiveActions.checked = true;
  }
}

var _arWorkflows = [];

function FUpdateworkflowControlStates(vbFieldChanged, vbForWorkflowTicketRows)
{
  var sValue = sDecodeURI(_oSelectedField.sGetFieldCustomization(vbForWorkflowTicketRows ? 0 : 1));
  document.formTableDesigner.txtTriggeringParameter.value = sValue ? sValue : "";

  if (vbForWorkflowTicketRows)
    return;

  $("#tableWorkflowSelection").css("display", "block");
  arOptions = document.formTableDesigner.cbxAvailableWorkflows.options;
  arOptions.length = 0;
  var sValue = _oSelectedField.sGetFieldCustomization(0);

  $.each(arFixInlinedObjectAttributes([<#ForEach attribute="actions:actiontypes=workflow" root="<#FullId>"  forcequeryparameters="1" where="" fields="fullid,name,viewurl,status.buttonlabel" sort="name" template="genericjsonobject.tpl" fieldtemplate="JsonFields\\generic$.tpl" fieldseparator=",">]), 
  function (viIndex, voWorkflow) {
    _arWorkflows[_arWorkflows.length] = {
      "psId" : voWorkflow.fullid,
      "psName" : voWorkflow.name,
      "psViewUrl" : voWorkflow.viewurl,
      "psButtonLabel" : voWorkflow.status.buttonlabel
    };
    arOptions[arOptions.length] = new Option(voWorkflow.name, voWorkflow.fullid, sValue == voWorkflow.fullid, sValue == voWorkflow.fullid);
  });
}

function FUpdateworkflowforworkflowticketControlStates(vbFieldChanged, vbForWorkflowTicketRows)
{
  FUpdateworkflowControlStates(vbFieldChanged, true);
}

</script>
<!-- [QPRTemplateEnd: tabledesigner.tpl] -->
