<!DOCTYPE html>
<!-- [QPRTemplateStart: memorystate.tpl] -->
<html>
<head>
<title>QPR Web Application Server - Memory state</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta http-equiv="content-type" content="text/html;charset=<#CHARSET>">

<#PortalScript>
<link href="<#CSSFileLocation>booklet<#IsRTL true="_rtl">.css" rel="styleSheet" type="text/css" />

<style>
.MemoryMap * {
  font-family: Courier;
  font-size: 11px;
}
</style>

<script type="text/javascript">
var _sUIP = "<#UIP>";
var _bMemoryUsageMapShown = true;

function Reload()
{
  var sURL = sGetDocumentLocation();
  sURL = sSetParameter("UIP", _sUIP, sURL);
  document.location.replace(sURL);
}

function OnLoad()
{
  OnToggleShowMemoryUsageMap();
}

var _olStates = new Array();
var _olStateLabels = new Array();
var _sMemoryUsageMap = "";
var _iNumberOfModels = 0, _iMemoryUsage, _iTotalCacheSize = 0, _iLargestContinuousFreeMemoryBlock, _iMemoryUsageMapChunkSize;
var _olPendingLoads = new Array(), _olPendingUnloads = new Array(), _olPendingCaches = new Array();

function MemoryState(viMemoryUsage, vsMemoryUsageMap, viMemoryUsageMapChunkSize, viLargestContinuousFreeMemoryBlock)
{
  _iMemoryUsage = viMemoryUsage;
  _iLargestContinuousFreeMemoryBlock = viLargestContinuousFreeMemoryBlock;
  _sMemoryUsageMap = vsMemoryUsageMap;
  _iMemoryUsageMapChunkSize = viMemoryUsageMapChunkSize;
}

function ModelState(viModelId, vsModel, vsState, viCacheFileSize)
{
  var olModels = _olStates[vsState];
  if (!olModels) {
    olModels = new Array();
    _olStates[vsState] = olModels;
  }
  var iSize = (viCacheFileSize >= 0) ? viCacheFileSize : 0;
  olModels[olModels.length] = {
    piId : viModelId,
    psModel : vsModel,
    psState : vsState,
    piSize : iSize,
    pbSizeAvailable : (viCacheFileSize > -1)
  };
  _iTotalCacheSize += iSize;
  ++_iNumberOfModels;
}

function sGetMoveToCacheURL(viModelId)
{
  var sURL = sGetBaseURL("PGPLUGIN", "puop");
  sURL = sSetParameter("OP", "movetocache", sURL);
  sURL = sSetParameter(ACT_PARAM_MODEL, viModelId, sURL);
  sURL = sSetParameter("FOO", (new Date()).valueOf(), sURL);
  return sURL;
}

function sGetLoadIntoMemoryURL(viModelId)
{
  var sURL = sGetBaseURL("PGPLUGIN", "puop");
  sURL = sSetParameter("op", "load", sURL);
  sURL = sSetParameter(ACT_PARAM_MODEL, viModelId, sURL);
  sURL = sSetParameter("FOO", (new Date()).valueOf(), sURL);
  return sURL;
}

function sGetUnloadURL(viModelId)
{
  var sURL = sGetBaseURL("PGPLUGIN", "puop");
  sURL = sSetParameter("op", "unload", sURL);
  sURL = sSetParameter(ACT_PARAM_MODEL, viModelId, sURL);
  sURL = sSetParameter("FOO", (new Date()).valueOf(), sURL);
  return sURL;
}

function MoveToCache(viModelId, vbDontReload)
{
  var oWorkerFrame = document.getElementById("workerframe");
  oWorkerFrame.src = sGetMoveToCacheURL(viModelId);
  if (!vbDontReload)
    document.location.reload(true);
}

function LoadIntoMemory(viModelId, vbDontReload)
{
  var oWorkerFrame = document.getElementById("workerframe");
  oWorkerFrame.src = sGetLoadIntoMemoryURL(viModelId);
  if (!vbDontReload)
    document.location.reload(true);
}

function Unload(viModelId, vbDontReload)
{
  var oWorkerFrame = document.getElementById("workerframe");
  oWorkerFrame.src = sGetUnloadURL(viModelId);
  if (!vbDontReload)
    document.location.reload(true);
}

function Open(viModelId)
{
  var sURL = sGetBaseURL("PGPLUGIN", "xlink");
  sURL = sSetParameter("VTN", "flowchart", sURL);
  sURL = sSetParameter(ACT_PARAM_MODEL, viModelId, sURL);
  sURL = sSetParameter("SKIN", "portal", sURL);
  sURL = sSetParameter("PMAIN", "processes", sURL);
  sURL = sSetParameter("PSUB", "PGPLUGIN_processmaps", sURL);
  sURL = sSetParameter("PPRM", sEncodeURI("MODELID=" + viModelId + "?0"), sURL);
  OpenBrowser(sURL, "_blank", 800, 600); 
}

function AppendModelsWithState(vsState, volList)
{
  var olModels = _olStates[vsState];
  if (olModels) {
    for (var i = 0; i < olModels.length; ++i) {
      var oModel = olModels[i];
      volList[volList.length] = oModel;
    }
  }
}

function LoadAll()
{
  AppendModelsWithState("Not loaded", _olPendingLoads);
  ProcessNext();
}

function CacheAll()
{
  AppendModelsWithState("Loading", _olPendingCaches);
  AppendModelsWithState("Not loaded", _olPendingCaches);
  AppendModelsWithState("In memory", _olPendingCaches);
  ProcessNext();
}

function UnloadAll()
{
  AppendModelsWithState("Loading", _olPendingUnloads);
  AppendModelsWithState("Cached", _olPendingUnloads);
  AppendModelsWithState("In memory", _olPendingUnloads);
  ProcessNext();
}

function ProcessNext()
{
  if (_olPendingLoads && (_olPendingLoads.length > 0)) {
    LoadIntoMemory(_olPendingLoads[_olPendingLoads.length - 1].piId, true);
    _olPendingLoads.length--;
  }
  else if (_olPendingCaches && (_olPendingCaches.length > 0)) {
    MoveToCache(_olPendingCaches[_olPendingCaches.length - 1].piId, true);
    _olPendingCaches.length--;
  }
  else if (_olPendingUnloads && (_olPendingUnloads.length > 0)) {
    Unload(_olPendingUnloads[_olPendingUnloads.length - 1].piId, true);
    _olPendingUnloads.length--;
  }
}

function onOperationCompleted(vsResult)
{
  ProcessNext();
}

function DumpForState(vsState)
{
  var olModels = _olStates[vsState];
  if (olModels) {
    for (var i = 0; i < olModels.length; ++i) {
      var oModel = olModels[i];
      var sButtons = sGetButtonHTML("Load", "javascript:LoadIntoMemory(" + oModel.piId + ")") + "&nbsp;" +
                     sGetButtonHTML("Cache", "javascript:MoveToCache(" + oModel.piId + ")") + "&nbsp;" +
                     sGetButtonHTML("Unload", "javascript:Unload(" + oModel.piId + ")");
                     
      var sModel = "<a href=\"javascript:Open(" + oModel.piId + ");\">" + oModel.psModel + "<\/a>";
      var sSize = oModel.pbSizeAvailable ? oModel.piSize : "Unavailable";
      document.write("<tr><td>" + oModel.piId + "</td><td>" + sModel + "</td><td>" + oModel.psState + "</td><td>" + sSize + "</td><td>" + sButtons + "</td></tr>");   
    }
  }
}

function iGetNumberOfModelsInState(vsState)
{
  if (_olStates[vsState])
    return _olStates[vsState].length;
  return 0;
}

function OnToggleShowMemoryUsageMap()
{
  var oShowButton = document.getElementById("btnToggleMemoryMap");
  var oMemoryMapTable = document.getElementById("tableMemoryMap");
  _bMemoryUsageMapShown = !_bMemoryUsageMapShown;
  if (_bMemoryUsageMapShown) {
    oMemoryMapTable.style.display = "block";
    oShowButton.innerHTML = "[&nbsp;Hide&nbsp;Memory&nbsp;Usage&nbsp;Map&nbsp;]";
  }
  else {
    oMemoryMapTable.style.display = "none";
    oShowButton.innerHTML = "[&nbsp;Show&nbsp;Memory&nbsp;Usage&nbsp;Map&nbsp;]";
  }
}

function DumpMemoryUsageMap()
{
  var CONST_CHARS_ON_ROW = 64;
  document.write("<a class='Button' id='btnToggleMemoryMap' href='javascript:OnToggleShowMemoryUsageMap()'>[&nbsp;Show&nbsp;Memory&nbsp;Usage&nbsp;Map&nbsp;]</a>");
  document.write("<table id='tableMemoryMap'><tr><td>");
  document.write("Every row in the following table represents " + parseInt((_iMemoryUsageMapChunkSize * CONST_CHARS_ON_ROW) / (1024 * 1024)) + " MB of memory:");
  document.write("<table class='MemoryMap'>");
  var iPos = 0;
  var iLen = _sMemoryUsageMap.length;
  var iAddress = 0;
  while (iPos < iLen) {
    document.write("<tr>");
    document.write("<th>" + "0x" + iAddress.toString(16) + "</th>");
    document.write("<td>" + _sMemoryUsageMap.substr(iPos, (CONST_CHARS_ON_ROW < (iLen - iPos) + 1) ? CONST_CHARS_ON_ROW : (iLen - iPos) + 1) + "</td>");
    iAddress += _iMemoryUsageMapChunkSize * CONST_CHARS_ON_ROW;
    iPos += CONST_CHARS_ON_ROW;
    document.write("</tr>");
  }

  document.write("</table></td></tr></table><br /><br />");
}

function DumpMemoryState()
{
  document.write("<table><tr><td>Memory usage:</td><td>" + _iMemoryUsage + " (" + parseInt(_iMemoryUsage / (1024 * 1024)) + " MB)</td></tr>" + 
                        "<tr><td>Largest continuous free memory block size:</td><td>" + _iLargestContinuousFreeMemoryBlock + " (" + parseInt(_iLargestContinuousFreeMemoryBlock / (1024 * 1024)) + " MB)</td></tr>" +
                        "<tr><td>Total file cache size:</td><td>" + _iTotalCacheSize + " (" + parseInt(_iTotalCacheSize / (1024 * 1024)) + " MB)</td></tr>" +
                        "<tr><td>Total number of models:</td><td>" + _iNumberOfModels + "</td></tr>" + 
                        "<tr><td>Number of models being loaded:</td><td>" + iGetNumberOfModelsInState("Loading") + "</td></tr>" +
                        "<tr><td>Number of models in memory:</td><td>" + iGetNumberOfModelsInState("In memory") + "</td></tr>" +
                        "<tr><td>Number of cached models:</td><td>" + iGetNumberOfModelsInState("Cached") + "</td></tr>" +
                        "<tr><td>Number of published models not loaded from the server:</td><td>" + iGetNumberOfModelsInState("Not loaded") + "</td></tr>" +
                        "<tr><td>Number of models that are not published:</td><td>" + iGetNumberOfModelsInState("Not loaded (Not published)") + "</td></tr></table>");
  document.write("<br />");
  DumpMemoryUsageMap();
} 

function DumpModelStates()
{
  document.write("<br/><table><tr><th>Id</th><th>Model</th><th>State</th><th>Cache size</th><th>Operations</tr><tr>");

  DumpForState("Loading");
  DumpForState("In memory");
  DumpForState("Cached");
  DumpForState("Not loaded");
  DumpForState("Not loaded (Not published)");

  document.write("</table>");
}
</script>

</head>
<body onLoad="OnLoad()">
  <iframe id="workerframe" src="" style="display: none">
  </iframe>
  <input type="button" value="Refresh View" onClick="Reload()"><br/>
<script type="text/javascript">
  <#MemoryState memoryusagemap="1" largestblocksize="1">
  DumpMemoryState();
</script>
  <br />
  <input type="button" value="Load All" onClick="LoadAll()">
  <input type="button" value="Cache All" onClick="CacheAll()">
  <input type="button" value="Unload All" onClick="UnloadAll()">
<script type="text/javascript">
  DumpModelStates();
</script>
</body>
</html>
<!-- [QPRTemplateEnd: memorystate.tpl] -->
