<!DOCTYPE html>
<!-- [QPRTemplateStart: modelhierarchytreeview.tpl] -->

<html>
<head>
  <title>QPRPortal - <#Title></title>
  <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
  <meta http-equiv="content-type" content="text/html;charset=<#CHARSET>">

<#stylesheet>
<#PortalScript>  

<#Include template="jsobjectqueryhierarchyutils.tpl">
<#Include template="jshierarchytreeutils.tpl">
<#Include template="jsobjectquerypgutils.tpl">

<script>
function OnSOMVClick()
{
  var sUrl = sGetDocumentLocation();
  if (Toolbar.SOMV.checked)
    sUrl = sSetParameter("SOMV", "1", sUrl);
  else
    sUrl = sRemoveParameter("SOMV", sUrl);
  OpenView(sUrl);
}

function OpenModelLink(vsModelId)
{
  parent.OpenModelLink(vsModelId);
}

function AddHierarchyNode(vsLatestId, vsLabel, vsIconURL, vbIsModel, vsId, vbOpen, vbHasDynamicChildren)
{
  var sLinkURL = vbIsModel ? "javascript:OpenModelLink('" + vsLatestId + "')" : "";
  AddNormalNode(vsId, vsLabel, "<#PluginImageFileLocation>" + vsIconURL, sLinkURL, "PGPLUGINHierarchyRow", "tl", vbOpen, "", vbHasDynamicChildren);
}

function OnLoad()
{
  if (sGetParameter("SOMV", sGetDocumentLocation()) === "1")
    Toolbar.SOMV.checked = "checked";
}
</script>

<style>
  div.PropertyFormGroupWrapper
  {
    position: absolute;
    left: 8px;
    right: 8px;
    top: 80px;
    bottom: 32px;
  }

  #DetailsFooter 
  {
    position: absolute;
    height: 28px;
    left: 0px;
    bottom: 0px;
    right: 0px;
  }

  #divTree 
  {
    min-height: 40px;
  }
</style>
</head>
  <body class="PopupView" onLoad="OnLoad()" style="width: 100%; height: 100%; overflow: hidden">
    <div id="PopupHeader">
      <img src="<#PortalImageFileLocation>header_icon_select.png" />
      <h1>
        <#title>
      </h1>
    </div>
    <div class="PopupContent">
      <form id="Toolbar" name="Toolbar">
        <input type="checkbox" value="1" id="SOMV" name="SOMV" onclick="OnSOMVClick()" />
        <label for="SOMV"><#LocalizedText id="Show old model versions"></label>
      </form>
        
      <div class="PropertyFormGroupWrapper" style="overflow: auto;">
        <table class="GlossyPropertyFormGroup" cellspacing="0" cellpadding="0" style="width: 100%; height: 100%;">
          <tr>
            <td style="vertical-align: top;">
<script type="text/javascript">
  if (typeof(parent.callFunction) != "unknown")
    RegisterServerFunctionCallerFunction(parent.callFunction);
  InitializeHierarchy(true);
  <#Include template="jsdynamichierarchy.tpl" Hierarchy="pgmodels" SetVisible="<#URLParameter id="OID">" ExtraParameters=",showoldmodelversions=<#URLParameter id="SOMV" value="1" true="1" false="0">" ConfigurationFile="modelhierarchyfields.ini">
  UpdateTree();
  var _sSelectedId = sGetParameter("OID", sGetDocumentLocation());
  SetObjectSelectedStateByObjectIdValue(_sSelectedId);
</script>
            </td>
          </tr>
        </table>
      </div>
    </div>
    <div id="DetailsFooter">
      <input class="ButtonRight" type="button" value="<#hcancel>" onclick="parent.window.close()" style="margin-top: 0px !important;">
    </div>
  </body>
</html>
<!-- [QPRTemplateEnd: modelhierarchytreeview.tpl] -->
