<!DOCTYPE html>
<!-- [QPRTemplateStart: actionhierarchyframeview.tpl] --> 
<html>
  <head>
    <#Title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta http-equiv="content-type" content="text/html;charset=<#CHARSET>" />

    <link type="text/css" rel="styleSheet" href="<#CSSFileLocation>layout-default.css">
    <#stylesheet>    

<#Include template="jsportaltoolbarutils.tpl">
<#Include template="jsobjectqueryhierarchyutils.tpl">
<#Include template="jsutils.tpl">
<#Include template="jsactioncallutils.tpl">

<script type="text/javascript" src="<#ScriptFileLocation>actionhierarchyview.js"></script>    

<script type="text/javascript" src="<#CommonScriptFileLocation>jquery-ui.js"></script>
<script type="text/javascript" src="<#CommonScriptFileLocation>jquery.ui.touch-punch.js"></script>
<script type="text/javascript" src="<#CommonScriptFileLocation>jquery.layout.js"></script>

<script type="text/javascript">
  var _sEmptyPageURL = "<#PageFileLocation>empty.html";
  var _sTreeName = "ActionNavigatorView" + (new Date()).getTime();
  var _sInitialDetailsURL = _sEmptyPageURL, _bInitialDetailsURLSet = false;
  var _sDetailsURL = _sInitialDetailsURL;
  var _sOverrideDetailsURL;
  var _sCookieParameters = "";
  var _bCookiesSet = false;
  var _sLog = "";

  function bIsViewCompleted()
  {
    return _bTreeLoaded;
  }
  
  function sGetRootName()
  {
    return "<#Object attribute="prettyname" enc="js">";
  }

  function sGetBookmarkDefaultName()
  {
    var sBookmarkName = "<#LocalizedText id="Actions view" enc="js">";
    var sObjectName = sGetRootName();
    if (sObjectName.length > 0)
      sBookmarkName = sObjectName + " (" + sBookmarkName + ")";
    return sBookmarkName;
  }
  
  function sGetHeaderViewRightHTML()
  {
    return "<#LocalizedText id="View:">&nbsp;<#ViewSettingsName>";
  }

  var oMainView = oGetMainView();
  if (oMainView) {
    var _sTabPageName = oMainView.sGetTabPageNameReadFromCookie();
    if (!_sTabPageName) {
      var oHeaderView = oGetHeaderView();
      if (oHeaderView)
        _sTabPageName = oHeaderView.sGetViewDescriptor();
    }
    
    if (_sTabPageName == "processes")
      CopyParametersToHierarchyViewParameters("PGAC_");
    else if (_sTabPageName == "scorecards")
      CopyParametersToHierarchyViewParameters("SCAC_");
    else
      CopyParametersToHierarchyViewParameters("POAC_");
  }

  function oGetBasketItemView(voOpener)
  {
    if (voOpener && voOpener.name && (voOpener.name == "Details"))
      return voOpener;
    return this;
  }

  function sModifyInformationViewUrlForDetailsPane(vsUrl)
  {
    var sCurrentUrl = sGetDocumentLocation();
    if ((sGetPlugin(vsUrl) === sGetPlugin(sCurrentUrl)) && 
        (sGetAction(vsUrl) === ACT_POR_ASSOCIATION_DETAILS_VIEW))
      vsUrl = sSetParameter("DEP", "1", vsUrl);
    return vsUrl;
  }
  
  function iGetMainViewHeight()
  {
    return $("#" + _sTreeName).height();
  }

  function oGetTree()
  {
    return eval("if (typeof(" + _sTreeName + ") != 'undefined') " + _sTreeName);
  }

  function OnPortalFramesResized()
  {
    if (IPAD)
    {
      var oTree = oGetTree();
      if (oTree && oTree.$ && oTree.$(oTree) && oTree.$(oTree).trigger)
        oTree.$(oTree).trigger("resize");
    }
  }
</script>
  </head>
  
<body style="width: 100%; height: 100%; overflow: hidden;" onLoad="OnLoadEx()" onUnload="OnUnload()">
<script type="text/javascript">
  if (bHasDetailsPane && bHasDetailsPane()) {
    document.write('<iframe id="' + _sTreeName + '" name="' + _sTreeName + '" src="<#PageFileLocation>empty.html" frameBorder="0" style="height: 100%; width: 100%; overflow: hidden; border: 0"></iframe>');
  }
  else {
    document.write('<div class="FrameScroller ui-layout-center"><iframe id="' + _sTreeName + '" name="' + _sTreeName + '" src="<#PageFileLocation>empty.html" frameBorder="0" style="height: 100%; width: 100%; border-bottom: 1px solid #a3c0dc;"></iframe></div>');
    document.write('<div class="FrameScroller ui-layout-south"><iframe id="Details" name="Details" class="ui-layout-south" src="<#PageFileLocation>empty.html" frameBorder="0" style="height: 100%; width: 100%; border: 0; border-top: 1px solid #a3c0dc;"></iframe></div>');
    $(document).ready(function () {
      $('body').layout( 
      {
        togglerTip_open: "",
        togglerTip_closed: "",
        center__maskContents: true,
        maskIframesOnResize: true,
        spacing_open: 6,
        spacing_closed: 6,
        resizerTip: "",
        sliderTip: "",
        closable: false,
        south__size: "40%",
        onresize: function () { window.setTimeout(OnPortalFramesResized, 10); }
      });
    });
    $('body').addClass("DetailsViewOpen");
  }
</script>
</body>
</html>
<!-- [QPRTemplateEnd: actionhierarchyframeview.tpl] -->
