<!DOCTYPE html>
<!-- [QPRTemplateStart: basketitemsselectionview.tpl] -->
<html>
  <head>
    <#Title>    
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta http-equiv="content-type" content="text/html;charset=<#CHARSET>">
    <#stylesheet>
    <#PortalScript>
    <script type="text/javascript" src="<#CommonScriptFileLocation>jquery.form.js"></script>

<script type="text/javascript">
  ResizePopupWindow();
  
  var sBookletViewExtraParameters;
  if ( bHasValidOpener(window) && (window.opener.sGetBookmarkExtraParameters))  {
    sBookletViewExtraParameters = window.opener.sGetBookmarkExtraParameters();
  }

  function BasketItem(vsPrettyName, vsValue)
  {
    this.psPrettyName = vsPrettyName;
    this.psValue = vsValue;
  }
    
  var _olViews = new Array();
  var _olDataItems = new Array();
  var _olElements = new Array();
  var _olBriefingItems = new Array();
  
  function AddView(vsPrettyName, vsValue)
  {
    _olViews.push(new BasketItem(vsPrettyName, vsValue + (sBookletViewExtraParameters ? sEncodeURI(sBookletViewExtraParameters + "|") : "")));
  }
   
  function AddDataItem(vsPrettyName, vsValue)
  {
    _olDataItems.push(new BasketItem(vsPrettyName, vsValue));
  }
  
  function AddElement(vsPrettyName, vsValue)
  {
    _olElements.push(new BasketItem(vsPrettyName, vsValue));
  }
  
  function AddBriefingItem(vsPrettyName, vsValue)
  {
    _olBriefingItems.push(new BasketItem(vsPrettyName, vsValue));
  }
  
  function ItemToOption(voSelect, voItem)
  {
    voSelect.options[voSelect.options.length] = new Option(voItem.psPrettyName, voItem.psValue);
  }
  
  function OutputItems()
  {
    var oSelect = formBasketItemSelection.lstAvailableItems;
    var oItem;

    if (_olElements.length > 0) {
      oSelect.options[oSelect.options.length] = new Option("--- " + sDecodeURI("<#LocalizedText id="ELEMENTS" enc="js">") + " ---", "SEP");
      for (var i = 0; i < _olElements.length; ++i)
        ItemToOption(oSelect, _olElements[i]);
    }

    if (_olViews.length > 0) {
      oSelect.options[oSelect.options.length] = new Option("--- " + sDecodeURI("<#LocalizedText id="VIEWS" enc="js">") + " ---", "SEP");
      for (var i = 0; i < _olViews.length; ++i)
        ItemToOption(oSelect, _olViews[i]);

    }

    if (_olDataItems.length > 0) {
      oSelect.options[oSelect.options.length] = new Option("--- " + sDecodeURI("<#LocalizedText id="BRIEFING ITEMS" enc="js">") + " ---", "SEP");
      for (var i = 0; i < _olDataItems.length; ++i)
        ItemToOption(oSelect, _olDataItems[i]);
    }

    if (_olBriefingItems.length > 0) {
      for (var i = 0; i < _olBriefingItems.length; ++i)
        ItemToOption(oSelect, _olBriefingItems[i]);
    }
  }

</script>
  </head>

  <body class="PopupView" onLoad="javascript: OnLoad();">
    <form name="formBasketItemSelection" action="<#FormAction>" method="post">
      <div id="PopupHeader">
        <img src="<#PortalImageFileLocation>header_icon_select.png" />
        <h1>
          <#HeaderText>                     
        </h1>
      </div>
      <div class="PopupContent">
        <div class="PropertyFormGroupWrapper">
          <table class="GlossyPropertyFormGroup" cellspacing="0" cellpadding="0" width="100%">
            <tr>
              <td style="width: 100%;">
                <select id="lstAvailableItems" style="width: 100%;" name="ITM" size="12" multiple onChange="javascript: setButtonState();">
<script type="text/javascript">
  var oInformationView = oGetInformationView();
  if (oInformationView && oInformationView.oGetBasketItemView && bHasValidOpener(window))
    oInformationView = oInformationView.oGetBasketItemView(window.opener);
  if (!(bHasValidOpener(window) && 
        oInformationView && 
        (typeof(oInformationView.bGetBasketItems) != "undefined") &&
        oInformationView.bGetBasketItems(AddView, AddDataItem, AddElement, AddBriefingItem))) {
<#AvailableItems>
  }
<#BriefingItems>
</script>
                </select>
              </td>
            </tr>   
          </table>
        </div>
      </div>
      <div id="DetailsFooter">
        <input class="ButtonRight" type="button" value="<#LocalizedText id="Help">" onclick="javascript: OnHelp();">
        <input class="ButtonRight" type="button" value="<#LocalizedText id="Cancel">" onclick="javascript: window.close();">
        <#From true="<!--">
        <input type="hidden" name="BASKET_ADD" value="OK" />
        <input class="ButtonRight" type="button" name="OK" value="<#LocalizedText id="OK">" onclick="javascript: return(OnAddBasket());">
        <#From true="-->">
        <#From false="<!--">
        <input class="ButtonRight" type="button" name="OK" value="<#LocalizedText id="OK">" onclick="javascript: OnOk();">
        <#From false="-->">
      </div>
    </form>
<script language="JavaScript1.2">

<#Include template="jsBasketObject.tpl">
  function OutputObjects()
  {
    document.formBasketItemSelection.lstAvailableItems.options.length = 0;

    var t, olObjects, oObject, iNumAssociations = 0, iNumExternals = 0;

    for (var i = 0; i < _<#Name>olObjects.length; ++i) {
      olObjects = _<#Name>olObjects[i];

      for (t = 0; t < olObjects.length; ++t) {
        oObject = olObjects[t];
        oObject.WriteObjectAsSelectOption(document.formBasketItemSelection.lstAvailableItems);
      }
    }
  }

  function OnHelp()
  {
    OpenHelpWindow(sDecodeURI('<#HelpURL>?basket.htm'));
  }

  function OnLoad()
  {
    OutputItems();

    var sObjects = "<#MyBasketObjects>";
    if (sObjects.length > 0) 	
    {
      ReadObjects(sDecodeURI(sObjects));
      OutputObjects();
    }  
    setButtonState();
    InitializeResizeHandlerForPopup(window);
  }

  function setButtonState()
  {
    <#From false="UnselectSeparators();">
    document.formBasketItemSelection.OK.disabled = (!(document.formBasketItemSelection.lstAvailableItems.length > 0) || !(document.formBasketItemSelection.lstAvailableItems.selectedIndex > -1) );
  }

  <#From false="/*">
  function OnOk()
  {
    if (bHasValidOpener(window) && window.opener.<#CallbackFunction>)
    {
      var olResult = new Array();
      var oOption, olOptions = document.formBasketItemSelection.lstAvailableItems.options;

      if (olOptions.selectedIndex == -1)
      {
        alert(sDecodeURI('<#LocalizedTextMessage id="No items selected">'));
        return; 
      }
   
      for (var i = 0; i < olOptions.length; ++i)
      {
        oOption = olOptions[i];
        if (oOption.selected)
          olResult.push(oGetObjectWithId(oOption.value));
      }
      window.opener.<#CallbackFunction>(olResult);
      window.opener.focus();
    }
    window.close(); 
  }
  <#From false="*/">

  <#From true="/*">
  function UnselectSeparators()
  {
    for (var i = 0; i < document.formBasketItemSelection.lstAvailableItems.length; ++i)
    {
      if ((document.formBasketItemSelection.lstAvailableItems.options[i].selected) && 
          (document.formBasketItemSelection.lstAvailableItems.options[i].value == 'SEP'))
      {
        document.formBasketItemSelection.lstAvailableItems.options[i].selected = false;
      }
    }
  }

  function OnAddBasket()
  {
    UnselectSeparators();
    if (document.formBasketItemSelection.lstAvailableItems.selectedIndex == -1)
    {
     alert(sDecodeURI('<#LocalizedTextMessage id="No items selected">'));
     return;
    }

    document.formBasketItemSelection.OK.disabled = true;

    var options =  {
      success: function() {
        window.close();
      }
    };
    $(document.formBasketItemSelection).ajaxSubmit(options);
  }
  <#From true="*/">

</script>
  </body>
</html>
<!-- [QPRTemplateEnd: basketitemsselectionview.tpl] -->
