<!DOCTYPE html>
<!-- [QPRTemplateStart: bookletpageitemsview.tpl] -->
<html>
  <head>
    <#Title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta http-equiv="content-type" content="text/html;charset=<#CHARSET>">
    <link href="<#CSSFileLocation>booklet<#IsRTL true="_rtl">.css" rel="styleSheet" type="text/css" />
    <#PortalScript>
    <script type="text/javascript">

      ResizePopupWindow(490, 330);

      function setParentTitle() {
        top.document.title = document.title;
        setButtonState();
      }

      function openBookletHelp()
      {
        OpenHelpWindow(sDecodeURI('<#BookletHelpURL>?briefingitems.htm'));
      }

      function sGetSelectedID(oObject)
      {
        var list = oObject.options;
      
        if (list.selectedIndex >= 0) {
          var selectedItem = list[list.selectedIndex];
               
          return selectedItem.value;
        } else {
          return '';
        }
      }        
      
      function refreshView()
      {
        var sItemID = sGetSelectedID(document.forms['formPageItems'].elements['lstItems']);
      
        if (sItemID == '') {
          sItemID = "-1";
        }
      
        var sURL = '<#PageItemsURL>&<#ParamSelectedItem>=' + sItemID;
            
        parent.location.href = sURL;
      }
      
      function eventHandler(result, data)
      {     
        if (!(result == "OK") && (data.length > 0))
        {
          window.alert(data);
        }
        refreshView();
      }
      
      function addItem()
      {
        OpenWindow('<#AddItemURL>', 'AddItemWindow', 380, 300);
      }       
      
      function removeItem()
      {
        var sItemID = sGetSelectedID(document.forms['formPageItems'].elements['lstItems']);
        
        if (!(sItemID == '')) {
          if (confirm(sDecodeURI('<#LocalizedTextMessage id="Are you sure you want to remove the briefing item?">'))) {                              
            var sURL = "<#RemoveItemURL>&<#BookletObjectIDID>=" + sItemID;
            parent.callFunction(sURL, eventHandler);
          }
        }
      }
      
      function openProperties()
      {
        var sItemID = sGetSelectedID(document.forms['formPageItems'].elements['lstItems']);
        
        if (!(sItemID == '')) {
          var sURL = "<#PropertiesURL>&<#BookletObjectIDID>=" + sItemID;
          OpenWindow(sURL, 'PageItemProperties', 380, 400, true);
        }
      }      
      
      function moveUp()
      {
        var sItemID = sGetSelectedID(document.forms['formPageItems'].elements['lstItems']);

        if (!(sItemID == '')) {
          var sURL = "<#MoveItemURL>&<#BookletObjectIDID>=" + sItemID + "&<#DirectionID>=1";
          parent.callFunction(sURL, eventHandler);
        }
      }     

      function moveDown()
      {
        var sItemID = sGetSelectedID(document.forms['formPageItems'].elements['lstItems']);

        if (!(sItemID == '')) {
          var sURL = "<#MoveItemURL>&<#BookletObjectIDID>=" + sItemID + "&<#DirectionID>=2";
          parent.callFunction(sURL, eventHandler);
        }
      }      
    
      function openPreview()
      {
        var sItemID = sGetSelectedID(document.forms['formPageItems'].elements['lstItems']);
        
        if (!(sItemID == '')) {
          var sURL = "<#ItemPreviewURL>&<#BookletObjectIDID>=" + sItemID;
          OpenWindow(sURL, 'ItemPreviewWindow', 500, 400, true);
        }
      } 
      
      function closeWindow()
      {
      	parent.window.close();
      	self.window.close();      	
      	window.close();
      }       

      function setButtonState()
      {
        var oForm = document.forms['formPageItems'];
        var oOptions = oForm.elements['lstItems'].options;

        if ((oOptions.length > 0) && (oOptions.selectedIndex > -1)) {
          oForm.elements['btnRemove'].disabled = false;
          oForm.elements['btnProperties'].disabled = false;
          oForm.elements['btnPreview'].disabled = false;
          oForm.elements['btnMoveUp'].disabled = (oOptions.selectedIndex == 0);
          oForm.elements['btnMoveDown'].disabled = (oOptions.selectedIndex == oOptions.length - 1);
        } else {
          oForm.elements['btnRemove'].disabled = true;
          oForm.elements['btnProperties'].disabled = true;
          oForm.elements['btnMoveUp'].disabled = true;
          oForm.elements['btnMoveDown'].disabled = true;
          oForm.elements['btnPreview'].disabled = true;
        }    
      }
      function OnLoad()
      {
        setParentTitle();
        InitializeResizeHandlerForPopup(window);
      }
    </script>
  </head>
  <body onLoad="OnLoad()" rightmargin="0" topmargin="0">

      <form name="formPageItems">
      <table border="0" cellspacing="4" cellpadding="0" width="100%" height="1">
      <tr height="1%">
        <td class="ElementTitle">&nbsp;&nbsp;<#LocalizedText id="Briefing Items"> - <#PageName></td>
      </tr>
         <tr>
            <td class="TableCellPaddingBackground">
               <table border="0" cellpadding="2" cellspacing="1" nowrap="true" width="100%" height="1">
                  <tr height="1%" class="ControlGroup">
                     <td>
                        <table style="classic" width="100%" border="0" cellpadding="2" nowrap="true">
                           <tr>
                              <td width="100%">
                                <table style="width:100%; border-collapse:collapse; table-layout:fixed;"> 
                                  <tr>
                                    <td>
                                      <select class="classic" name="lstItems" size="11" style="width: 100%" onChange="javascript: setButtonState();">
                                      <#PageItems>
                                      </select>
                                    </td>
                                  </tr>
                                </table>
                              </td>
                              <td valign="top">
                                 <table border="0" cellpadding="0" cellspacing="0" width="67">
                                    <tr>
                                       <td><input type="button" name="btnAdd" style="width: 100px" value="<#LocalizedText id="Add">" onClick="javascript: addItem();"></td>
                                    </tr>
                                    <tr height="3">
                                       <td height="3"></td>
                                    </tr>
                                    <tr>
                                       <td><input type="button" name="btnRemove" style="width: 100px" value="<#LocalizedText id="Remove">" onClick="javascript: removeItem();"></td>
                                    </tr>
                                    <tr height="3">
                                       <td height="3"></td>
                                    </tr>
                                    <tr>
                                       <td><input type="button" name="btnProperties" style="width: 100px" value="<#LocalizedText id="Properties">" onClick="javascript: openProperties();"></td>
                                    </tr>
                                    <tr height="10">
                                       <td height="10"></td>
                                    </tr>
                                    <tr>
                                       <td><input type="button" name="btnMoveUp" style="width: 100px" value="<#LocalizedText id="Move Up">" onClick="javascript: moveUp();"></td>
                                    </tr>
                                    <tr height="3">
                                       <td height="3"></td>
                                    </tr>
                                    <tr>
                                       <td><input type="button" name="btnMoveDown" style="width: 100px" value="<#LocalizedText id="Move Down">" onClick="javascript: moveDown();"></td>
                                    </tr>
                                    <tr height="15">
                                       <td height="15"></td>
                                    </tr>
                                    <tr>
                                       <td><input type="button" name="btnPreview" style="width: 100px" value="<#LocalizedText id="Preview">" onClick="javascript: openPreview();"></td>
                                    </tr>
                                    <tr>
                                       <td></td>
                                    </tr>
                                 </table>
                              </td>
                           </tr>
                        </table>
                     </td>
                  </tr>
               </table>
            </td>
         </tr>
         <tr>
           <td align="<#IsRTL true="left" false="right">">
             <input type="button" style="width: 100px" value="<#LocalizedText id="Close">" onClick="javascript: closeWindow();"/>
             <input type="button" style="width: 100px" value="<#LocalizedText id="Help">" onClick="javascript: openBookletHelp()" />
           </td>
         </tr>
      </table>
      </form>
   </body>
 </html>
<!-- [QPRTemplateEnd: bookletpageitemsview.tpl] -->
