// [QPRTemplateStart: sc_jsviewutils.tpl]

  function OnLastPeriodSet(vsPeriodId, vsDate)
  {
    var oHView=oGetHeaderView();
    if (oHView)
    {
      oHView.SetNamedVariableValue('LASTSELPERID', vsPeriodId, false);
      oHView.SetNamedVariableValue('LASTSELPERDATE', vsDate, false);
    }
  }
  function OnLastSeriesSet(vsSeriesId)
  {
    var oHView=oGetHeaderView();
    if (oHView)
    {
      oHView.SetNamedVariableValue('LASTSELPATID', vsSeriesId, false);
    }
  }
  function init()
  {
    var sPeriodId;
    var sPeriodDate;
    var sSeriesId;
    var oHView=oGetHeaderView();
    if (oHView)
    {
      sPeriodId = oHView.sGetNamedVariableValue('LASTSELPERID', false);
      sPeriodDate = oHView.sGetNamedVariableValue('LASTSELPERDATE', false);
      sSeriesId = oHView.sGetNamedVariableValue('LASTSELPATID', false);
    }
    else
    {
      sPeriodId = sCreateExternalObjectId(PR_SC, <#Model attribute="id">, '<#UsedPeriodID>');
      sPeriodDate = '';
      sSeriesId = sCreateExternalObjectId(PR_SC, <#Model attribute="id">, '<#UsedSeriesID>');
    }
    if ((parent) && (parent.callFunction))
    {
      parent.callFunction('<#SetCookieValueURL key="LASTSELPERID" product="QPRPORTAL">&SCV=' + sPeriodId);
      parent.callFunction('<#SetCookieValueURL key="LASTSELPERDATE" product="QPRPORTAL">&SCV=' + sPeriodDate);
      parent.callFunction('<#SetCookieValueURL key="LASTSELPATID" product="QPRPORTAL">&SCV=' + sSeriesId);
    }
  }

  function sGetSeriesToolbarButtonHTML(vbFromObjectQueryView)
  {
    if (vbFromObjectQueryView)
      return sGetToolbarIconButtonHTML("<#LocalizedText id="Series">", "javascript:oGetInformationViewFrame().OpenSeriesSelectionViewFromToolbar()", "<#PortalImageFileLocation>icon_series.png");
    else
      return sGetToolbarIconButtonHTML("<#LocalizedText id="Series">", "javascript:OpenWindow(\"" + sAddJavascriptEscapes("<#SelectSeries>") + "\", \"SC_SERIES\", 400, 410, true)", "<#PortalImageFileLocation>icon_series.png");
  }
  
  function sGetOfficeExportButtonHTML()
  {
    var oMainView = oGetMainView();
  return !oMainView || !oMainView.bIsLicensedPowerPointExport() || IPAD ||
         <#HasRights product="portal" level="update" true="false" false="true">
         ? '' :
           sGetToolbarIconButtonHTML("<#LocalizedText id="Export to Office">", "javascript:oGetInformationViewFrame().OfficeExport()", "<#PortalImageFileLocation>icon_office.png");
  }

  function sGetPeriodToolbarButtonHTML(vbFromObjectQueryView)
  {
    if (vbFromObjectQueryView)
      return sGetToolbarIconButtonHTML("<#LocalizedText id="Period">", "javascript:oGetInformationViewFrame().OpenPeriodSelectionViewFromToolbar()", "<#PortalImageFileLocation>icon_period.png");
    else
      return sGetToolbarIconButtonHTML("<#LocalizedText id="Period">", "javascript:OpenWindow(\"<#SelectPeriodView>\", \"SC_PERIOD\", " + PERIODSELECTIONVIEW_WIDTH + ", " + PERIODSELECTIONVIEW_HEIGHT + ", true)", "<#PortalImageFileLocation>icon_period.png");
  }

  function sGetDefaultLocalToolbarButtons()
  {
    return sGetSeriesToolbarButtonHTML() +
           sGetToolbarIconButtonHTMLForSizedPopup("<#LocalizedText id="Views">", "<#SelectViewSettings>", 300, 200, "<#PortalImageFileLocation>icon_view_selection.png") +
           sGetPeriodToolbarButtonHTML() +
           sGetOfficeExportButtonHTML();
  }

  function sGetHeaderViewLeftHTML()
  {
    return sGetViewName();
  }
  
  function sGetHeaderViewRightHTML()
  {
    return "<#LocalizedText id="Period:">&nbsp;<#PeriodName>&nbsp;&nbsp;&nbsp;" +
           "<#LocalizedText id="Series:">&nbsp;<#SeriesName>&nbsp;&nbsp;&nbsp;" +
           "<#LocalizedText id="View:">&nbsp;<#ViewSettingsName>";
  }
  
  function sGetParametersFromUrl(vsUrl)
  {
    var sModelId = sGetParameter(ACT_PARAM_MODEL, vsUrl);
    var oHeaderView = oGetHeaderView();
    if (oHeaderView &&
        oHeaderView.sGetHierarchyViewParameter &&
       (oHeaderView.sGetHierarchyViewParameter('scorecards', ACT_PARAM_MODEL) != sModelId))
      return sSetParameter(ACT_PARAM_MODEL, sModelId, "");
    else
      return undefined;
  }

  function sGetObjectIdFromUrl(vsUrl)
  {
	return sCreateExternalObjectId(PR_SC, sGetParameter(ACT_PARAM_MODEL, vsUrl), sGetParameter("OBJ", vsUrl));
  }

  function sGetGraphicalViewTemplateName(vsKey)
  {
    var sResult = 'sc_' + vsKey + 'frameview';
    if ("<#SettingValue section="SCP Settings" key="GraphicalViewer">" === "3")
      sResult += '_silverlight';
    sResult += '.tpl';
    return sResult;
  }

  function OpenAnalysisView(vsUrl)
  {
    if (bInPortal())
      OpenPortalFrameset(vsUrl, 'scorecards', 'SCPLUGIN_analysis', sGetParametersFromUrl(vsUrl), sGetObjectIdFromUrl(vsUrl));
    else
      document.location = vsUrl;
  }
  
  function OpenNavigatorView(vsUrl)
  {
    if (bInPortal())
      OpenPortalFrameset(vsUrl, 'scorecards', 'SCPLUGIN_navigator', sGetParametersFromUrl(vsUrl), sGetObjectIdFromUrl(vsUrl));
    else
      document.location = vsUrl;
  }

  function OpenScorecardView(vsUrl)
  {
    if (bInPortal())
      OpenPortalFrameset(vsUrl, 'scorecards', 'SCPLUGIN_scorecards', sGetParametersFromUrl(vsUrl), sGetObjectIdFromUrl(vsUrl));
    else
      document.location = sSetParameter('TPL', sGetGraphicalViewTemplateName('sc'), vsUrl);
  }
  
  function OpenStrategyMapView(vsUrl)
  {
    if (bInPortal())
      OpenPortalFrameset(vsUrl, 'scorecards', 'SCPLUGIN_strategymaps', sGetParametersFromUrl(vsUrl), sGetObjectIdFromUrl(vsUrl));
    else
      document.location = sSetParameter('TPL', sGetGraphicalViewTemplateName('ce'), vsUrl);
  }
  
  function OpenActionsView(vsUrl, vsElementDetailsUrl)
  {
    if (bInPortal())
    {
      var oFrameset = oGetDetailsPaneFrameset();
      if (oFrameset && typeof(oFrameset.OpenDetailsPanePage) !== "undefined")
        oFrameset.OpenDetailsPanePage(vsElementDetailsUrl, "Actions");
      else
        OpenInformationView(vsUrl);
    }
    else
      document.location = vsUrl;
  }
  
  var _bSubmitting = false;
  
  function SubmitMeasureValues()
  {
    if (_bSubmitting)
      return;
    _bSubmitting = true;
      
    SubmitSCMeasureValues(
      document.formTable, 
      function (data) 
      {
        _bSubmitting = false;
        var oInformationView = oGetInformationView();
        if (!oInformationView)
          return;
        var url = sRemoveEditingParametersFromURL(sRemoveParameter(ACT_PARAM_EDIT, oInformationView.sGetDocumentLocation()));
        OpenInformationView(url);
      },
      function () 
      {
        _bSubmitting = false; 
        alert("<#LocalizedText enc="script" id="Unknown error occurred.">");
      }
    );
  }

  var configurations = [
    {identifier: "VSN", webserviceAttribute: "valuesettingsid", handlerFunction: "handleValueSettings"},
    {identifier: "DMUN", webserviceAttribute: "measureunitid", handlerFunction: "handleDefaultMeasureUnit"},
	//{identifier: "MUN", webserviceAttribute: "unit", handlerFunction: "handleMeasureUnit"},
    {identifier: "PLN",webserviceAttribute:  "periodlevelid", handlerFunction: "handlePeriodLevel"},
    {identifier: "GLT", webserviceAttribute: "graphlayouttemplateid", handlerFunction: "handleChartTemplates"},
	{identifier: "DPA", webserviceAttribute: "accumulationrule", handlerFunction: "handleAccumulationRules"},
	{identifier: "PN", webserviceAttribute: "name", handlerFunction: "handleMeasureName"},
	{identifier: "S", webserviceAttribute: "symbol", handlerFunction: "handleMeasureSymbol"},
	{identifier: "D", webserviceAttribute: "description", handlerFunction: "handleMeasureDescription"}
  ];
  var pendingCount = 0;
  
  function configureMeasures() {
    oGetMainView().configureMode = true;
    oGetMainView().RefreshToolbar();
	if (oGetMainView().oAccessor.oHiddenFrame == null) {
      oGetMainView().oAccessor.LoadProxy(configureMeasures_step2, handleError);
	} else {
	  configureMeasures_step2();
	}
  }
	
  function configureMeasures_step2() {
	for (var i = 0; i < configurations.length; i++) {
	  if (getColumnIndicesByIdentifier(configurations[i].identifier).length > 0) {
	    eval(configurations[i].handlerFunction + "()"); 
	  }
	}
  }
 
  function getColumnIndicesByIdentifier(identifier) {
    var viewColumns = sGetParameter("FE", sGetDocumentLocation()).split(",");
	var indeces = new Array();
	for (var i = 0; i < viewColumns.length; i++) {
	  if (viewColumns[i].substring(0, identifier.length + 1) == (identifier + ":")) {
	    indeces.push(i);
	  }
	}
	return indeces;
  }
  
  function getAttributeByIdentifier(identifier) {
	for (var item in configurations) {
	  if (configurations[item].identifier == identifier) {
	    return configurations[item].webserviceAttribute;
	  }
	}
	return null;
  }
  
  function getSeriesId(column) {
    //var viewColumns = sGetParameter("FE", sGetDocumentLocation()).split(",");
    //if (["MUN", "DPA"].indexOf(viewColumns[column].substring(0, viewColumns[column].indexOf(":"))) > -1) {
    return "";
  }
  
  function handleValueSettings() { if (oGetMainView().oAccessor.sSessionId == null) oGetMainView().oAccessor.AutoAuthenticate(getValueSettings_step2, handleError); else getValueSettings_step2();}
  function getValueSettings_step2() { oGetMainView().oAccessor.oClient.QueryObjects(oGetMainView().oAccessor.sSessionId, "[SC." + sGetParameter("MOD", sGetDocumentLocation()) + "].valuesetting", "", "name", "name", "", getValueSettings_step3, handleError); }
  function getValueSettings_step3(result) { handleResult(result, "VSN"); }
  
  function handleDefaultMeasureUnit() { if (oGetMainView().oAccessor.sSessionId == null) oGetMainView().oAccessor.AutoAuthenticate(getDefaultMeasureUnit_step2, handleError); else getDefaultMeasureUnit_step2();}
  function getDefaultMeasureUnit_step2() { oGetMainView().oAccessor.oClient.QueryObjects(oGetMainView().oAccessor.sSessionId, "[SC." + sGetParameter("MOD", sGetDocumentLocation()) + "].unit", "", "name", "name", "", getDefaultMeasureUnit_step3, handleError); }
  function getDefaultMeasureUnit_step3(result) { handleResult(result, "DMUN"); }
  
  function handleMeasureUnit() { if (oGetMainView().oAccessor.sSessionId == null) oGetMainView().oAccessor.AutoAuthenticate(getMeasureUnit_step2, handleError); else getMeasureUnit_step2();}
  function getMeasureUnit_step2() { oGetMainView().oAccessor.oClient.QueryObjects(oGetMainView().oAccessor.sSessionId, "[SC." + sGetParameter("MOD", sGetDocumentLocation()) + "].unit", "", "name", "name", "", getMeasureUnit_step3, handleError); }
  function getMeasureUnit_step3(result) { handleResult(result, "MUN"); }
  
  function handlePeriodLevel() { if (oGetMainView().oAccessor.sSessionId == null) oGetMainView().oAccessor.AutoAuthenticate(getPeriodLevel_step2, handleError); else getPeriodLevel_step2();}
  function getPeriodLevel_step2() { oGetMainView().oAccessor.oClient.QueryObjects(oGetMainView().oAccessor.sSessionId, "[SC." + sGetParameter("MOD", sGetDocumentLocation()) + "].periodlevel", "", "periodleveltype,name", "name", "", getPeriodLevel_step3, handleError); }
  function getPeriodLevel_step3(result) { handleResult(result, "PLN"); }
 
  function handleChartTemplates() { if (oGetMainView().oAccessor.sSessionId == null) oGetMainView().oAccessor.AutoAuthenticate(getChartTemplates_step2, handleError); else getChartTemplates_step2();}
  function getChartTemplates_step2() { oGetMainView().oAccessor.oClient.QueryObjects(oGetMainView().oAccessor.sSessionId, "[SC." + sGetParameter("MOD", sGetDocumentLocation()) + "].charttemplate", "", "name", "name", "", getChartTemplates_step3, handleError); }
  function getChartTemplates_step3(result) {  handleResult(result, "GLT"); }
  
  function handleResult(result, identifier) {
	if (result.ChildElements != null && result.ChildElements.length > 0) {
	  var columnIndices = getColumnIndicesByIdentifier(identifier);
	  for (var index in columnIndices) {
	    var rowIndex = 1;
	    while (true) {
	      var element = $("#col" + columnIndices[index] + "_" + rowIndex + "p");
		  if (element.size() == 0 || element.find("select").size() > 0) {
		    break;
		  }
	      var value = element.html();
		  var modelId = sGetParameter("MOD", sGetDocumentLocation());
		  var elementId = element.parent().parent().attr("objectid").replace("1_0_", "SC.").replace("_", ".");
		  element.empty();
	      element.append("<table style='width:100%;padding:0px;'><tbody><tr><td style='padding:0px;width:100%;'><select style='width:100%;' size='1' class='OptionStringEditor measureConfiguration' attribute='" + getAttributeByIdentifier(identifier) + getSeriesId(columnIndices[index]) + "' elementId='" + elementId + "' /></td><td style='width:1px;padding:0px;'><img alt='Apply to all' onclick=\"copyValueToAll(this);\" style='display:inline;margin-left:3px;cursor:pointer;' src='<#PortalImageFileLocation>copy_icon.png' /></td></tr></tbody></table>");
		  element.removeAttr("title");
	      if (value == null || value == "" || value == "&nbsp;") {
		    element.find("select").append("<option value='empty'></option>");
		  }
		  for (var i = 0; result.ChildElements != null && i < result.ChildElements.length; i++) {
   	        element.find("select").append("<option value='" + result.ChildElements[i].Id + "'>" + sHTMLEncode(result.ChildElements[i].ChildElements[0].Value) + "</option>");
		  }
		  element.find("select").children().each(function() {if ($(this).html() == value) {$(this).attr('selected', true);}});
		  element.find("select").attr("originalSetting", element.find("select").val());
          rowIndex++;
        }
	  }
	}
  }
    
  function handleAccumulationRules() {
  	var rowIndex = 1;
	while (true) {
	  var element = $("#col" + getColumnIndicesByIdentifier("DPA")[0] + "_" + rowIndex + "p");
	  if (element.size() == 0 || element.children("select").size() > 0) {
	    return;
	  }
	  var value = element.html();
	  var elementId = element.parent().parent().attr("objectid").replace("1_0_", "SC.").replace("_", ".");
	  element.empty();
	  element.append("<table style='width:100%;padding:0px;'><tbody><tr><td style='padding:0px;width:100%;'><select style='width:100%;' size='1' class='OptionStringEditor measureConfiguration' attribute='accumulationrule' elementId='" + elementId + "' /></td><td style='width:1px;padding:0px;'><img alt='Apply to all' onclick=\"copyValueToAll(this);\" style='display:inline;margin-left:3px;cursor:pointer;' src='<#PortalImageFileLocation>copy_icon.png' /></td></tr></tbody></table>");
	  if (value == null || value == "" || value == "&nbsp;") {
		element.find("select").append("<option value='empty'></option>");
	  }
	  for (var i = 0; i < _arPeriodicAccumulationEnumeration.length; i++) {
	    if (_arPeriodicAccumulationEnumeration[i][1] != "") {
   	      element.find("select").append("<option value='" + _arPeriodicAccumulationEnumeration[i][0] + "'>" + _arPeriodicAccumulationEnumeration[i][1] + "</option>");
		}
	  }
	  element.find("select").children().each(function() {if ($(this).html() == value) {$(this).attr('selected', true);}});
	  element.find("select").attr("originalSetting", element.find("select").val());
      rowIndex++;
    }
  }
  
  function handleMeasureName() {
 	var rowIndex = 1;
	while (true) {
	  var element = $("#col" + getColumnIndicesByIdentifier("PN")[0] + "_" + rowIndex + "p");
	  if (element.size() == 0 || element.find("input").size() > 0) {
	    return;
	  }
	  var value = element.html();
	  var elementId = element.parent().parent().attr("objectid").replace("1_0_", "SC.").replace("_", ".");
	  element.empty();
	  element.append("<table style='padding:0px;width:100%;'><tbody><tr><td style='padding:0px;'><input style='width:100%;' class='OptionStringEditor measureConfiguration' attribute='name' elementId='" + elementId + "' /></td><td style='width:1px;padding:0px;'><img alt='Apply to all' onclick=\"copyValueToAll(this);\" style='display:inline;margin-left:3px;cursor:pointer;' src='<#PortalImageFileLocation>copy_icon.png' /></td></tr></tbody></table>");
	  element.removeAttr("title");
	  element.find("input").val(value);
	  element.find("select").attr("originalSetting", value);
      rowIndex++;
    }
  }

  function handleMeasureSymbol() {
 	var rowIndex = 1;
	while (true) {
	  var element = $("#col" + getColumnIndicesByIdentifier("S")[0] + "_" + rowIndex + "p");
	  if (element.size() == 0 || element.find("input").size() > 0) {
	    return;
	  }
	  var value = element.html();
	  var elementId = element.parent().parent().attr("objectid").replace("1_0_", "SC.").replace("_", ".");
	  element.empty();
	  element.append("<table style='padding:0px;width:100%;'><tbody><tr><td style='padding:0px;'><input style='width:100%;' class='OptionStringEditor measureConfiguration' attribute='symbol' elementId='" + elementId + "' /></td><td style='width:1px;padding:0px;'><img alt='Apply to all' onclick=\"copyValueToAll(this);\" style='display:inline;margin-left:3px;cursor:pointer;' src='<#PortalImageFileLocation>copy_icon.png' /></td></tr></tbody></table>");
	  element.removeAttr("title");
	  element.find("input").val(value);
	  element.find("input").attr("originalSetting", value);
      rowIndex++;
    }
  }
  
  function handleMeasureDescription() {
 	var rowIndex = 1;
	while (true) {
	  var element = $("#col" + getColumnIndicesByIdentifier("D")[0] + "_" + rowIndex + "p");
	  if (element.size() == 0 || element.find("textarea").size() > 0) {
	    return;
	  }
	  var value = element.html();
	  var elementId = element.parent().parent().attr("objectid").replace("1_0_", "SC.").replace("_", ".");
	  element.empty();
	  element.append("<table style='padding:0px;width:100%;'><tbody><tr><td style='padding:0px;'><textarea style='width:100%;' class='OptionStringEditor measureConfiguration' attribute='description' elementId='" + elementId + "' /></td><td style='width:1px;padding:0px;'><img alt='Apply to all' onclick=\"copyValueToAll(this);\" style='display:inline;margin-left:3px;cursor:pointer;' src='<#PortalImageFileLocation>copy_icon.png' /></td></tr></tbody></table>");
	  element.removeAttr("title");
	  element.find("textarea").val(value);
	  element.find("textarea").attr("originalSetting", value);
      rowIndex++;
    }
  }
  
  function copyValueToAll(thisElement) {
    var thisValue = $(thisElement).parent().prev().children("input,textarea,select").val()
	var thisLabel = thisValue;
	if ($(thisElement).parent().prev().children("input,textarea,select").is("select")) {
	  thisLabel = $(thisElement).parent().prev().children("input,textarea,select").children("option:selected").text();
	}
	var answer = confirm("Copy following value to all: \"" + thisLabel + "\"?");
	if (answer) {
	  var thisAttribute = $(thisElement).parent().prev().children("input,textarea,select").attr("attribute");
	  $("input[attribute=\"" + thisAttribute + "\"],textarea[attribute=\"" + thisAttribute + "\"],select[attribute=\"" + thisAttribute + "\"]").val(thisValue);
	}
  }
  
  function handleError(result) {
    var errorMessage = "";
	if (result != null && typeof(result.get_message) != "undefined") { 
	  errorMessage = result.get_message();
	}
    alert("Error occured. Please try again in a moment.\n\nError message:\n" + errorMessage);
	oGetMainView().oAccessor.sSessionId = null;
  }
  
  function saveMeasureSettings() {
    $(".measureConfiguration").each(function() {
      if ($(this).attr("originalSetting") != $(this).val() && ((($(this).attr("attribute") == "name" || $(this).attr("attribute") == "symbol") && $(this).val() != "") || ($(this).attr("attribute") != "name" && $(this).attr("attribute") != "symbol"))) {
	    pendingCount++;
	    oGetMainView().oAccessor.oClient.SetAttribute(oGetMainView().oAccessor.sSessionId, $(this).attr("elementId"), $(this).attr("attribute"), $(this).val(), "", attributeSaveReady, handleError);
	  }
    });
	if (pendingCount == 0) {
	  oGetMainView().configureMode = false;
	  oGetMainView().RefreshToolbar();
	  Reload();
	}
  }
  
  function cancelMeasureConfiguration() {
    oGetMainView().configureMode = false;
	oGetMainView().RefreshToolbar();
	Reload();
  }
  
  function attributeSaveReady() {
    pendingCount--;
	if (pendingCount == 0) {
      oGetMainView().configureMode = false;
	  oGetMainView().RefreshToolbar();
	  Reload();
	}
  }
  
// [QPRTemplateEnd: sc_jsviewutils.tpl]